From af56555734c975ff7742ab4e7d9e33a36fd45da9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Bastien=20ROUCARI=C3=88S?= <roucaries.bastien@gmail.com>
Date: Tue, 14 Mar 2017 18:25:07 +0100
Subject: [PATCH 1/5] Allow pkg-conff-obsolete to run with DPKG_ROOT

---
 Makefile                                           |  3 +-
 t-conffile-obsolete/Makefile                       | 36 +++++++++++-----------
 .../pkg-conff-obsolete-2/DEBIAN/preinst            |  2 +-
 3 files changed, 20 insertions(+), 21 deletions(-)

diff --git a/Makefile b/Makefile
index 996fab1..a96df30 100644
--- a/Makefile
+++ b/Makefile
@@ -97,9 +97,8 @@ TESTS_PASS += t-file-replaces
 TESTS_PASS += t-file-replaces-disappear
 TESTS_PASS += t-file-replaces-versioned
 TESTS_PASS += t-conffile-normal
-ifndef DPKG_NOT_ROOT
-# FIXME: dpkg-maintscript-helper does not support $DPKG_ROOT (#832176)
 TESTS_PASS += t-conffile-obsolete
+ifndef DPKG_NOT_ROOT
 # FIXME: Somehow pkg-conff-takeover cannot take over /test-conffile
 TESTS_PASS += t-conffile-orphan
 endif
diff --git a/t-conffile-obsolete/Makefile b/t-conffile-obsolete/Makefile
index 89a4499..5fdda82 100644
--- a/t-conffile-obsolete/Makefile
+++ b/t-conffile-obsolete/Makefile
@@ -5,37 +5,37 @@ include ../Test.mk
 test-case:
 	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
 	$(DPKG_INSTALL) pkg-conff-obsolete-1.deb
-	test -f /test-conffile
+	test -f '$(DPKG_INSTDIR)/test-conffile'
 	$(DPKG_PURGE) pkg-conff-obsolete
-	test ! -f /test-conffile
+	test ! -f '$(DPKG_INSTDIR)/test-conffile'
 	# Unmodified conffile is autoremoved for the user
 	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
 	$(DPKG_UNPACK) pkg-conff-obsolete-2.deb
-	test -f /test-conffile.dpkg-remove
-	test ! -f /test-conffile.dpkg-backup
+	test -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'
 	$(DPKG_CONFIGURE) pkg-conff-obsolete
-	test ! -f /test-conffile
-	test ! -f /test-conffile.dpkg-bak
-	test ! -f /test-conffile.dpkg-backup
-	test ! -f /test-conffile.dpkg-remove
+	test ! -f '$(DPKG_INSTDIR)/test-conffile'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
 	$(DPKG_PURGE) pkg-conff-obsolete
 	# Modified conffile is moved away in .dpkg-bak for the user
 	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
-	$(BEROOT) sh -c "echo foo >>/test-conffile"
+	$(BEROOT) sh -c "echo foo >> '$(DPKG_INSTDIR)/test-conffile'"
 	$(DPKG_INSTALL) pkg-conff-obsolete-2.deb
-	test ! -f /test-conffile
-	test -f /test-conffile.dpkg-bak
+	test ! -f '$(DPKG_INSTDIR)/test-conffile'
+	test -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
 	$(DPKG_PURGE) pkg-conff-obsolete
-	test ! -f /test-conffile.dpkg-bak
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
 	# Abort-upgrade restores the to-be-removed conffile
 	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
-	$(BEROOT) touch /fail-preinst
+	$(BEROOT) touch '$(DPKG_INSTDIR)/fail-preinst'
 	$(DPKG_INSTALL) pkg-conff-obsolete-2.deb || true
-	$(BEROOT) rm -f /fail-preinst
-	test -f /test-conffile
-	test ! -f /test-conffile.dpkg-remove
-	test ! -f /test-conffile.dpkg-bak
-	test ! -f /test-conffile.dpkg-backup
+	$(BEROOT) rm -f '$(DPKG_INSTDIR)/fail-preinst'
+	test -f '$(DPKG_INSTDIR)/test-conffile'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
+	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'
 
 test-clean:
 	$(DPKG_PURGE) pkg-conff-obsolete
diff --git a/t-conffile-obsolete/pkg-conff-obsolete-2/DEBIAN/preinst b/t-conffile-obsolete/pkg-conff-obsolete-2/DEBIAN/preinst
index de6b54a..c0e592b 100755
--- a/t-conffile-obsolete/pkg-conff-obsolete-2/DEBIAN/preinst
+++ b/t-conffile-obsolete/pkg-conff-obsolete-2/DEBIAN/preinst
@@ -3,7 +3,7 @@ if dpkg-maintscript-helper supports rm_conffile; then
     dpkg-maintscript-helper rm_conffile /test-conffile 0 -- "$@"
 fi
 
-if [ -e /fail-preinst ]; then
+if [ -e "$DPKG_ROOT/fail-preinst" ]; then
     exit 1
 fi
 
-- 
2.11.0

